SystemOrganization addCategory: #InteractiveBisect!

Announcement subclass: #NewRecommendationNumberForBisectAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InteractiveBisect'!

Object subclass: #InteractiveBisect
	instanceVariableNames: 'announcer integerMode inputNumber tooSmallNumber tooBigNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InteractiveBisect'!

!InteractiveBisect methodsFor: 'changing' stamp: 'hjo 8/2/2011 11:31'!
beIntegerMode

	self integerMode: true! !

!InteractiveBisect methodsFor: 'defaults' stamp: 'hjo 8/2/2011 11:27'!
defaultForIntegerMode

	^false! !

!InteractiveBisect methodsFor: 'helper' stamp: 'hjo 8/2/2011 12:54'!
inputMiddleNumber
	self inputNumber: (tooSmallNumber + tooBigNumber) / 2.0! !

!InteractiveBisect methodsFor: 'accessing' stamp: 'hjo 8/2/2011 12:36'!
inputNumber

	^inputNumber! !

!InteractiveBisect methodsFor: 'accessing' stamp: 'hjo 8/2/2011 12:38'!
inputNumber: aNumber 

	inputNumber := self numberToSet: aNumber! !

!InteractiveBisect methodsFor: 'accessing' stamp: 'hjo 8/2/2011 11:26'!
integerMode

	^integerMode setDefault: #defaultForIntegerMode for: self   withSetter: #integerMode:   ! !

!InteractiveBisect methodsFor: 'accessing' stamp: 'hjo 8/30/2011 20:53'!
integerMode: aBoolean 

	integerMode := aBoolean.
	aBoolean ifTrue: 
		[
			tooSmallNumber := tooSmallNumber truncated.
			self changed: #tooSmallNumber.
			tooBigNumber := tooBigNumber truncated.
			self changed: #tooBigNumber.
			inputNumber := inputNumber truncated.
			self changed: #inputNumber.  
		]! !

!InteractiveBisect methodsFor: 'testing' stamp: 'hjo 8/2/2011 11:27'!
isIntegerMode

	^self integerMode! !

!InteractiveBisect methodsFor: 'helper' stamp: 'hjo 8/2/2011 11:39'!
numberToSet: aFloat 

	^self isIntegerMode ifTrue: [aFloat truncated] ifFalse: [aFloat]! !

!InteractiveBisect methodsFor: 'changing' stamp: 'hjo 8/30/2011 20:23'!
reset
	inputNumber := nil.
	tooSmallNumber := nil.
	tooBigNumber := nil.

	self changed: #inputNumber.
	self changed: #tooSmallNumber.
	self changed: #tooBigNumber.! !

!InteractiveBisect methodsFor: 'testing' stamp: 'hjo 8/2/2011 12:10'!
shouldCopyToClipboard

	^self stringOfInputNumber notEmpty! !

!InteractiveBisect methodsFor: 'printing' stamp: 'hjo 8/2/2011 12:48'!
stringOfInputNumber

	^self stringOrNullString: inputNumber  ! !

!InteractiveBisect methodsFor: 'printing' stamp: 'hjo 8/2/2011 12:49'!
stringOfTooBigNumber

	^self stringOrNullString: tooBigNumber  ! !

!InteractiveBisect methodsFor: 'printing' stamp: 'hjo 8/2/2011 12:49'!
stringOfTooSmallNumber

	^self stringOrNullString: tooSmallNumber  ! !

!InteractiveBisect methodsFor: 'helper' stamp: 'hjo 8/2/2011 12:47'!
stringOrNullString: aNumber

	^aNumber isNil 
		ifTrue: [ '' ]
		ifFalse: [ aNumber asString ]! !

!InteractiveBisect methodsFor: 'changing' stamp: 'hjo 8/30/2011 20:50'!
treatTheNumberTooBig

	tooBigNumber := self inputNumber.
	self changed: #tooBigNumber.
	self tryToAnnounceComputedNumber! !

!InteractiveBisect methodsFor: 'changing' stamp: 'hjo 8/30/2011 20:50'!
treatTheNumberTooSmall

	tooSmallNumber := self inputNumber.
	self changed: #tooSmallNumber.
	self tryToAnnounceComputedNumber! !

!InteractiveBisect methodsFor: 'helper' stamp: 'hjo 8/30/2011 20:24'!
tryToAnnounceComputedNumber
	(tooSmallNumber notNil and: [ tooBigNumber notNil ])
		ifTrue: [ 
			self inputMiddleNumber.
			self changed: #inputNumber   ]! !

Object subclass: #InteractiveBisectModel
	instanceVariableNames: 'bisect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InteractiveBisect'!

!InteractiveBisectModel methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 16:39'!
bisect 

	^bisect setDefault: #defaultBisect for: self  withSetter:  #bisect:! !

!InteractiveBisectModel methodsFor: 'as yet unclassified' stamp: 'hjo 8/30/2011 20:39'!
bisect: anInteractiveBisect

	bisect ifNotNil: [bisect removeDependent: self].
	bisect := anInteractiveBisect.
	bisect addDependent: self.  ! !

!InteractiveBisectModel methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 16:39'!
defaultBisect

	^InteractiveBisect new! !

!InteractiveBisectModel methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 17:05'!
enableForStaticText

	^false! !

!InteractiveBisectModel methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 17:06'!
getEnableSelectorForStaticText

	^#enableForStaticText! !

!InteractiveBisectModel methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 16:41'!
inputNumber

	^self bisect inputNumber! !

!InteractiveBisectModel methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 17:48'!
inputNumber: aByteString 

	(aByteString notNil and: [aByteString isEmpty not])
		ifTrue: [ self bisect inputNumber: aByteString asNumber ]! !

!InteractiveBisectModel methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 20:05'!
inputNumberChanged: anAnnouncement

	self changed: #stringOfTooSmallNumber.
	self changed: #stringOfTooBigNumber.
	self changed: #inputNumber.! !

!InteractiveBisectModel methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 16:51'!
integerMode: aBoolean

	self bisect integerMode: aBoolean! !

!InteractiveBisectModel methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 16:41'!
isIntegerMode

	^self bisect isIntegerMode! !

!InteractiveBisectModel methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 16:53'!
isIntegerMode: aBoolean

	self bisect integerMode: aBoolean! !

!InteractiveBisectModel methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 16:56'!
reset

	self bisect reset! !

!InteractiveBisectModel methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 17:22'!
stringOfTooBigNumber

	^self bisect stringOfTooBigNumber! !

!InteractiveBisectModel methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 17:04'!
stringOfTooSmallNumber

	^self bisect stringOfTooSmallNumber! !

!InteractiveBisectModel methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 16:50'!
treatTheNumberTooBig

	self bisect treatTheNumberTooBig! !

!InteractiveBisectModel methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 16:50'!
treatTheNumberTooSmall

	self bisect treatTheNumberTooSmall! !

!InteractiveBisectModel methodsFor: 'as yet unclassified' stamp: 'hjo 8/30/2011 20:49'!
update: aSymbol

	aSymbol = #inputNumber ifTrue: [ ^self changed: #inputNumber ].
	aSymbol = #tooSmallNumber ifTrue: [^self changed:  #stringOfTooSmallNumber ].
	aSymbol = #tooBigNumber ifTrue: [^self changed:  #stringOfTooBigNumber ].
	self halt.  ! !

StandardWindow subclass: #InteractiveBisectWindow
	instanceVariableNames: 'ls i lb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InteractiveBisect'!

!InteractiveBisectWindow classSide methodsFor: 'window color' stamp: 'hjo 8/11/2011 17:17'!
patchworkUIThemeColor
	"Answer a default color for UI themes that make use of different colors for Browser, MessageList etc..."

	^ Color lightGray! !

!InteractiveBisectWindow methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2011 17:17'!
addInitialPanel
	"Add the panel."

	self addMainPanel! !

!InteractiveBisectWindow methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2011 17:17'!
addMainPanel
	"Add the main panel."

	self addMorph: self newMainPanel frame: (0@0 corner: 1@1)! !

!InteractiveBisectWindow methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2011 17:17'!
cancel
	"Cancel and close."

	self close! !

!InteractiveBisectWindow methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2011 17:17'!
close
	"Close the window."

	self delete! !

!InteractiveBisectWindow methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 14:05'!
defaultIsIntegerMode

	^false! !

!InteractiveBisectWindow methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 10:45'!
defaultLabel
	"Answer the default label for the receiver."

	^'Simpler Binary Search' translated! !

!InteractiveBisectWindow methodsFor: 'defaults' stamp: 'hjo 8/12/2011 16:40'!
defaultModel

	^InteractiveBisectModel new.! !

!InteractiveBisectWindow methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 15:14'!
getInputNumber

	^self model inputNumber isNil ifTrue: [String new] ifFalse: [self model inputNumber printString]! !

!InteractiveBisectWindow methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 10:43'!
initialExtent

	^371@158! !

!InteractiveBisectWindow methodsFor: 'initialization' stamp: 'hjo 8/12/2011 14:46'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		addInitialPanel! !

!InteractiveBisectWindow methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 14:49'!
isIntegerMode

	^self model isIntegerMode! !

!InteractiveBisectWindow methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 14:50'!
isIntegerMode: aBoolean 

	self model integerMode: aBoolean  ! !

!InteractiveBisectWindow methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2011 17:17'!
isResizeable
	"Answer whether we are not we can be resized."

	^false! !

!InteractiveBisectWindow methodsFor: 'event handling' stamp: 'hjo 8/11/2011 17:17'!
keyStroke: evt
	"Check for return and escape keys."

	super keyStroke: evt.
	(self defaultButton notNil and: [evt keyCharacter = Character cr]) ifTrue: [self returnPressed. ^true].
	evt keyCharacter = Character escape ifTrue: [self escapePressed. ^true].
	^false! !

!InteractiveBisectWindow methodsFor: 'event handling' stamp: 'hjo 8/11/2011 17:17'!
keyboardFocusChange: aBoolean
	"Set the focus to the default button."

	aBoolean ifTrue: [
		self defaultFocusMorph ifNotNil: [:b |
			b takeKeyboardFocus]]! !

!InteractiveBisectWindow methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2011 17:17'!
mainPanel
	"Anwer the main panel morph or nil if not yet present."

	^self paneMorphs isEmpty
		ifFalse: [self paneMorphs first]! !

!InteractiveBisectWindow methodsFor: 'accessing' stamp: 'hjo 8/12/2011 14:44'!
model

	^model setDefault: #defaultModel for: self  withSetter:  #model:! !

!InteractiveBisectWindow methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2011 18:10'!
newContentMorph
	"Answer a new content morph."

	| morph |
	morph := Morph new
		color: Color transparent;
		changeTableLayout;
		cellInset: 8;
		listDirection: #leftToRight;
		listCentering: #bottomCenter;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.

	morph addMorphBack: (ls := self newLabelFor: self model getLabel: #stringOfTooSmallNumber getEnabled: #enableForStaticText).
	morph addMorphBack: (i := (self newTextEntryFor: self model getText: #inputNumber setText: #inputNumber: help: 'input number') autoAccept: true).
	morph addMorphBack: (lb := self newLabelFor: self model getLabel: #stringOfTooBigNumber getEnabled: #enableForStaticText).
	^morph! !

!InteractiveBisectWindow methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2011 17:17'!
newMainPanel
	"Answer a new main panel."

	^self newDialogPanel
		addMorphBack: self newContentMorph;
		addMorphBack: self newButtonRow;
		yourself! !

!InteractiveBisectWindow methodsFor: 'theme' stamp: 'hjo 8/11/2011 17:17'!
preferredCornerStyle
	"Answer the preferred corner style."

	^self theme dialogWindowPreferredCornerStyleFor: self! !

!InteractiveBisectWindow methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2011 17:17'!
returnPressed
	"Default is to do the default button."

	(self defaultButton ifNil: [^self]) performAction! !

!InteractiveBisectWindow methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2011 17:17'!
setButtonFont: aFont
	"Set the font for the buttons."

	| buttons e|
	buttons := self buttons.
	e := 0@0.
	buttons do: [:b | | hRes vRes |
		hRes := b hResizing.
		vRes := b vResizing.
		b
			hResizing: #shrinkWrap;
			vResizing: #shrinkWrap.
		b label: b label font: aFont.
		e := e max: b minExtent.
		b
			hResizing: hRes;
			vResizing: vRes].
	buttons do: [:b | b extent: e]! !

!InteractiveBisectWindow methodsFor: 'initialization' stamp: 'hjo 8/11/2011 17:17'!
setFramesForLabelArea
	"Delegate to theme."
	
	self theme configureDialogWindowLabelAreaFrameFor: self! !

!InteractiveBisectWindow methodsFor: 'controls' stamp: 'hjo 8/11/2011 17:17'!
title: aString
	"Set the window title."
	
	super title: aString.
	label fitContents.
	self minimumExtent: ((label width + 20 min: (Display width // 2))@ self minimumExtent y)! !

!InteractiveBisectWindow methodsFor: 'theme' stamp: 'hjo 8/11/2011 17:17'!
wantsRoundedCorners
	"Answer whether rounded corners are wanted."
	
	^(self theme dialogWindowPreferredCornerStyleFor: self) == #rounded! !

TestCase subclass: #InteractiveBisectTest
	instanceVariableNames: 'bisect gotTooSmallNumberChanged gotTooBigNumberChanged gotInputNumberChanged'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InteractiveBisect'!

!InteractiveBisectTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/30/2011 20:30'!
setUp

	super setUp.
	gotTooSmallNumberChanged := false.
	gotInputNumberChanged := false. "rename this variable to gotNumberChanged"
	gotTooBigNumberChanged := false.
	bisect := InteractiveBisect new.
	bisect addDependent: self.! !

!InteractiveBisectTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/30/2011 20:19'!
tearDown

	bisect breakDependents.
	super tearDown.! !

!InteractiveBisectTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/2/2011 12:37'!
testIntegerMode

	self deny: bisect isIntegerMode.
	bisect beIntegerMode.
	self assert: bisect isIntegerMode.

	bisect inputNumber: 0.4.
	bisect treatTheNumberTooSmall.
	self assert: (bisect stringOfInputNumber) equals: '0'. "0.4 is truncated to 0"

	bisect inputNumber: 15.655.
	bisect treatTheNumberTooBig.
	self assert: (bisect stringOfInputNumber) equals: '7'. "(int)((0.0+15.0)/2)"
	bisect treatTheNumberTooBig.
	self assert: (bisect stringOfInputNumber) equals: '3'. "(int)((0.0+7.0)/2)"
	bisect treatTheNumberTooSmall.
	self assert: (bisect stringOfInputNumber) equals: '5'. "(int)((3.0+7.0)/2)"
	bisect treatTheNumberTooBig.
	self assert: (bisect stringOfInputNumber) equals: '4'. "(int)((3.0+5.0)/2)"! !

!InteractiveBisectTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/30/2011 20:30'!
testReset

	bisect inputNumber: 10.0.
	bisect treatTheNumberTooBig.
	bisect inputNumber: 0.0.
	bisect treatTheNumberTooSmall.
	gotInputNumberChanged := false.
	bisect reset.
	self assert: gotInputNumberChanged.
	self assert: bisect inputNumber isNil.
	self deny: bisect shouldCopyToClipboard.
	self assert: bisect stringOfTooSmallNumber equals: ''.
	self assert: bisect stringOfInputNumber equals: ''.
	self assert: bisect stringOfTooBigNumber equals: ''.

	gotInputNumberChanged := false.
	bisect inputNumber: 6.0.
	bisect treatTheNumberTooSmall.
	self deny: gotInputNumberChanged.
	self assert: (bisect stringOfInputNumber) equals: '6.0'.
! !

!InteractiveBisectTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/1/2011 23:07'!
testSetUp

	self assert: bisect notNil! !

!InteractiveBisectTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/30/2011 20:30'!
testTooBig

	bisect inputNumber: 0.0.
	bisect treatTheNumberTooBig.
	self assert: bisect shouldCopyToClipboard.
	self deny: gotInputNumberChanged.
	self assert: bisect stringOfTooSmallNumber equals: ''.
	self assert: bisect stringOfInputNumber equals: '0.0'.
	self assert: bisect stringOfTooBigNumber equals: '0.0'.! !

!InteractiveBisectTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/30/2011 20:30'!
testTooBigTooSmall

	bisect inputNumber: 10.0.
	bisect treatTheNumberTooBig.
	self assert: bisect stringOfTooSmallNumber equals: ''.
	self assert: bisect stringOfInputNumber equals: '10.0'.
	self assert: bisect stringOfTooBigNumber equals: '10.0'.
	
	bisect inputNumber: 0.0.
	bisect treatTheNumberTooSmall.
	self assert: bisect stringOfTooSmallNumber equals: '0.0'.
	self assert: bisect stringOfInputNumber equals: '5.0'.
	self assert: bisect stringOfTooBigNumber equals: '10.0'.

	self assert: gotInputNumberChanged.
	self assert: bisect inputNumber asNumber equals: 5.0.  
	"STAssertEqualsWithAccuracy(5.0, [[binarySearch inputNumber] doubleValue], 0.0001, nil);"! !

!InteractiveBisectTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/30/2011 20:30'!
testTooBigTooSmallTooBig

	bisect inputNumber: 10.0.
	bisect treatTheNumberTooBig.
	self assert: bisect stringOfTooSmallNumber equals: ''.
	self assert: bisect stringOfInputNumber equals: '10.0'.
	self assert: bisect stringOfTooBigNumber equals: '10.0'.

	bisect inputNumber: 0.0.
	bisect treatTheNumberTooSmall.

	self assert: bisect stringOfTooSmallNumber equals: '0.0'.
	self assert: bisect stringOfInputNumber equals: '5.0'.
	self assert: bisect stringOfTooBigNumber equals: '10.0'.

	gotInputNumberChanged := false.
	bisect treatTheNumberTooBig.
	self assert: gotInputNumberChanged.
	self assert: (bisect inputNumber asNumber) equals: 2.5.
	"STAssertEqualsWithAccuracy(2.5, [[bisect inputNumber] doubleValue], 0.0001, nil);"
	self assert: bisect stringOfTooSmallNumber equals: '0.0'.
	self assert: bisect stringOfInputNumber equals: '2.5'.
	self assert: bisect stringOfTooBigNumber equals: '5.0'.
! !

!InteractiveBisectTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/30/2011 20:30'!
testTooBigTooSmallTooSmll

	bisect inputNumber: 10.0.
	bisect treatTheNumberTooBig.
	self assert: bisect stringOfTooSmallNumber equals: ''.
	self assert: bisect stringOfInputNumber equals: '10.0'.
	self assert: bisect stringOfTooBigNumber equals: '10.0'.

	bisect inputNumber: 0.0.
	bisect treatTheNumberTooSmall.
	self assert: bisect stringOfTooSmallNumber equals: '0.0'.
	self assert: bisect stringOfInputNumber equals: '5.0'.
	self assert: bisect stringOfTooBigNumber equals: '10.0'.

	gotInputNumberChanged := false.
	bisect treatTheNumberTooSmall.
	self assert: gotInputNumberChanged.
	self assert: (bisect inputNumber asNumber) equals: 7.5.
	"STAssertEqualsWithAccuracy(7.5, [[bisect inputNumber] doubleValue], 0.0001, nil);"
	self assert: bisect stringOfTooSmallNumber equals: '5.0'.
	self assert: bisect stringOfInputNumber equals: '7.5'.
	self assert: bisect stringOfTooBigNumber equals: '10.0'.
! !

!InteractiveBisectTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/30/2011 20:30'!
testTooSmall

	bisect  inputNumber: 0.0.
	bisect treatTheNumberTooSmall.
	self assert: bisect shouldCopyToClipboard.
	self deny: gotInputNumberChanged.  
	self assert: bisect stringOfTooSmallNumber equals: '0.0'.
	self assert: bisect stringOfInputNumber equals: '0.0'.
	self assert: bisect stringOfTooBigNumber equals: ''. 
! !

!InteractiveBisectTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/30/2011 20:30'!
update: aSymbol

	super update: aSymbol.  
	aSymbol == #inputNumber ifTrue: [ gotInputNumberChanged := true. ].
	aSymbol == #tooSmallNumber ifTrue: [ gotTooSmallNumberChanged := true. ].
	aSymbol == #tooBigNumber ifTrue: [ gotTooBigNumberChanged := true. ].! !
